catalog/urls.py
from django.urls import path, re_path
from . import views

urlpatterns = [
    path('', views.index, name='index'),
    path('books/', views.BookListView.as_view(), name='books'),
    path('book/<int:pk>', views.BookDetailView.as_view(), name='book-detail'),
    path('authors/', views.AuthorListView.as_view(), name='authors'),
    re_path(r'^author/(?P<pk>\d+)$', views.AuthorDetailView.as_view(), name='author-detail'),
    path('mybooks/', views.BorrowedBooksListView.as_view(), name='my-borrowed'),
    path('myreservations/', views.ReservedBooksListView.as_view(), name='my-reserved'),
    path('book/<uuid:pk>/cancel-reservation/', views.cancel_reservation, name='cancel-res'),
    path('borrowedbooks/', views.LoanedBooksListView.as_view(), name='all-borrowed'),
    path('book/<uuid:pk>/borrow/', views.borrow_book, name='borrow-book'),
    path('book/<uuid:pk>/reserve/', views.reserve_book, name='reserve-book'),
    path('book/<uuid:pk>/renew/', views.renew_book_with_modelform, name='renew-book-librarian'),
    path('book/<uuid:pk>/return/', views.return_loaned_book, name='return-book'),
    path('author/create/', views.AuthorCreate.as_view(), name='author-create'),
    path('author/<int:pk>/update/', views.AuthorUpdate.as_view(), name='author-update'),
    path('author/<int:pk>/delete/', views.AuthorDelete.as_view(), name='author-delete'),
]

locallibrary/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('catalog/', include('catalog.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

catalog/models/author.py
import datetime

from django.core.exceptions import ValidationError
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _


class Author(models.Model):
    """Model representing an author."""
    first_name = models.CharField(max_length=100)
    last_name = models.CharField(max_length=100)
    date_of_birth = models.DateField('Born', null=True, blank=True)
    date_of_death = models.DateField('Died', null=True, blank=True)

    class Meta:
        ordering = ['last_name', 'first_name']

    def get_absolute_url(self):
        """Returns the url to access a particular author instance."""
        return reverse('author-detail', args=[str(self.id)])

    def __str__(self):
        """String for representing the Model object."""
        return f'{self.last_name}, {self.first_name}'

    def clean(self):
        super().clean()
        if self.date_of_death and self.date_of_birth and self.date_of_birth > self.date_of_death:
            raise ValidationError(message=_('Date of birth cannot be after date of Death'), code='invalid')
        if self.date_of_death and self.date_of_death > datetime.date.today():
            raise ValidationError(message=_('Date of Death cannot be in the future'), code='invalid')
        if self.date_of_birth and self.date_of_birth > datetime.date.today():
            raise ValidationError(message=_('Date of Birth cannot be in the future'), code='invalid')

catalog/models/book.py
from django.db import models
from django.urls import reverse

from catalog.models.genre import Genre


class Book(models.Model):
    """Model representing a book (but not a specific copy of a book)."""
    title = models.CharField(max_length=200, help_text='Enter the book title (e.g. Lonesome Dove)')

    # Foreign Key used because book can only have one author, but authors can have multiple books
    # Author as a string rather than object because it hasn't been declared yet in the file
    author = models.ForeignKey('Author', on_delete=models.SET_NULL, null=True)

    summary = models.TextField(max_length=1000, help_text='Enter a brief description of the book')
    isbn = models.CharField('ISBN', max_length=13,
                            help_text='13 Character <a href="https://www.isbn-international.org/content/what-isbn">ISBN number</a>')

    # ManyToManyField used because genre can contain many books. Books can cover many genres.
    # Genre class has already been defined so we can specify the object above.
    genre = models.ManyToManyField(Genre, help_text='Select a genre for this book (e.g. Science Fiction)')

    language = models.ForeignKey('Language', on_delete=models.SET_NULL, null=True)

    def __str__(self):
        """String for representing the Model object."""
        return self.title

    def get_absolute_url(self):
        """Returns the url to access a detail record for this book."""
        return reverse('book-detail', args=[str(self.id)])

    # Getting the genre may not be a good idea here, because of the "cost" of the database operation.
    # We're showing you how because calling functions in your models can be very useful for other reasons
    # — for example to add a Delete link next to every item in the list.
    def display_genre(self):
        """Create a string for the Genre. This is required to display genre in Admin."""
        return ', '.join(genre.name for genre in self.genre.all()[:3])

    display_genre.short_description = 'Genre'

catalog/models/bookinstance.py
from datetime import date
from django.core.exceptions import ValidationError
from django.utils.translation import gettext_lazy as _
from django.db import models
from django.contrib.auth.models import User
import uuid


class BookInstance(models.Model):
    """Model representing a specific physical copy of a book (i.e. that can be borrowed from the library)."""

    # UUIDField is used for the id field to set it as the primary_key for this model.
    # This type of field allocates a globally unique value for each instance
    id = models.UUIDField(primary_key=True, default=uuid.uuid4,
                          help_text='Unique ID for this particular book across whole library')

    # One book can have multiple instances in the library
    book = models.ForeignKey('Book', on_delete=models.SET_NULL, null=True)
    imprint = models.CharField(max_length=200)
    due_back = models.DateField(null=True, blank=True)
    borrower = models.ForeignKey(User, on_delete=models.SET_NULL, null=True, blank=True, related_name='borrower')
    reserver = models.ForeignKey(User, on_delete=models.SET_NULL, null=True, blank=True, related_name='reserver')
    has_been_renewed = models.BooleanField(default=False)

    LOAN_STATUS = (
        ('m', 'Maintenance'),
        ('l', 'Loaned'),
        ('a', 'Available'),
        ('r', 'Reserved'),
    )

    status = models.CharField(
        max_length=1,
        choices=LOAN_STATUS,
        blank=True,
        default='m',
        help_text='Book availability',
    )

    # You can declare model-level metadata for your Model by declaring class Meta.
    # One of the most useful features of this metadata is to control the
    # default ordering of records returned when you query the model type.
    class Meta:
        ordering = ['due_back']
        permissions = (("can_mark_returned", "Set book as returned"),
                       ("can_see_own_borrowed_books", "See borrowed books"),
                       ("can_borrow_books", "Can borrow books"),
                       ("can_renew", "Can renew a book loan"),
                       )

    def __str__(self):
        """String for representing the Model object."""
        return f'{self.id} ({self.book.title})'

    @property
    def is_overdue(self):
        if self.due_back and date.today() > self.due_back:
            return True
        return False

    @property
    def is_reserved(self):
        if self.reserver:
            return True
        return False

    @property
    def is_renewable(self):
        if self.is_reserved or self.has_been_renewed:
            return False
        return True

    def clean(self):
        super().clean()
        if self.status == 'a' and self.due_back is not None:
            raise ValidationError(message=_('Available books may not have a "due back" date'), code='invalid')
        if self.status not in ('a', 'r') and self.due_back is None:
            raise ValidationError(message=_('Unavailable books must have a "due back" date'), code='invalid')
        if self.borrower and not self.borrower.groups.filter(permissions__codename__contains='can_borrow_books'):
            raise ValidationError(message=_('Only users with borrow permission can borrow books'), code='invalid')
        if self.reserver and not self.reserver.groups.filter(permissions__codename__contains='can_borrow_books'):
            raise ValidationError(message=_('Only users with borrow permission can reserve books'), code='invalid')
        if self.status == 'l' and self.borrower is None:
            raise ValidationError(message=_('Loaned book must be loaned to someone innit?'), code='invalid')
        if self.status != 'l' and self.has_been_renewed:
            raise ValidationError(message=_('Only a loaned book can be renewed'), code='invalid')
        if self.status == 'r' and self.reserver is None:
            raise ValidationError(message=_('A reserved book must have a reserver'), code='invalid')
        if self.borrower and self.reserver and self.borrower == self.reserver:
            raise ValidationError(message=_("The same user can't borrow and reserve a book at the same time"),
                                  code='invalid')

catalog/models/genre.py
from django.db import models


class Genre(models.Model):
    """Model representing a book genre."""
    name = models.CharField(max_length=200, help_text='Enter a book genre (e.g. Science Fiction)')

    def __str__(self):
        """String for representing the Model object."""
        return self.name

catalog/models/language.py
from django.db import models


class Language(models.Model):
    """Model representing a Language (e.g. English, French, Japanese, etc.)"""
    name = models.CharField(max_length=200,
                            help_text="Enter the book's natural language (e.g. English, French, Japanese etc.)")

    def __str__(self):
        """String for representing the Model object (in Admin site etc.)"""
        return self.name

catalog/forms.py
import datetime

from django import forms
from django.core.exceptions import ValidationError
from django.forms import ModelForm
from django.utils.translation import gettext_lazy as _

from catalog.models import BookInstance


class RenewBookForm(forms.Form):
    renewal_date = forms.DateField(help_text="Enter a date between now and 4 weeks (default 3).")

    def clean_renewal_date(self):
        data = self.cleaned_data['renewal_date']

        # Check if a date is not in the past.
        if data < datetime.date.today():
            raise ValidationError(_('Invalid date - renewal cannot be in the past'))

        # Check if a date is in the allowed range (+4 weeks from today).
        if data > datetime.date.today() + datetime.timedelta(weeks=4):
            raise ValidationError(_('Invalid date - renewal cannot be more than 4 weeks ahead from now'))

        # Remember to always return the cleaned data.
        return data


class RenewBookModelForm(ModelForm):

    def clean_due_back(self):
        new_due_date = self.cleaned_data['due_back']
        book_inst = self.instance

        # Check if a date is not in the past.
        if new_due_date < datetime.date.today():
            raise ValidationError(message=_('Invalid date - renewal in past'), code='invalid')

        # Check if the date is not before the original due date
        if new_due_date < book_inst.due_back:
            raise ValidationError(message=_('Invalid date - renewal before original due date'), code='invalid')

        # Check if a date is in the allowed range:
        if book_inst.is_overdue:
            # Max +4 weeks from original due date if the book is overdue
            if new_due_date > book_inst.due_back + datetime.timedelta(weeks=4):
                raise ValidationError(message=_('Invalid date - renewal more than 4 weeks ahead from original due date'),
                                      code='invalid')
        else:
            # Or max +4 weeks from today
            if new_due_date > datetime.date.today() + datetime.timedelta(weeks=4):
                raise ValidationError(message=_('Invalid date - renewal more than 4 weeks ahead from now'),
                                      code='invalid')

        # Remember to always return the cleaned form data.
        return new_due_date

    class Meta:
        model = BookInstance
        fields = ['due_back']
        labels = {'due_back': _('Renewal date')}
        help_texts = {'due_back': _('Enter a date between now and 4 weeks (default 3).')}

catalog/templates/catalog/author_confirm_delete.html
{% extends "catalog/base_generic.html" %}

{% block content %}

    <h1>Delete Author</h1>

    <p>Are you sure you want to delete the author: {{ author }}?</p>

    <form action="" method="POST">
        {% csrf_token %}
        <input class="btn btn-success" type="submit" value="Yes, delete.">
        <a href="{{ author.get_absolute_url }}">
            <button class="btn btn-danger" type="button">Cancel</button>
        </a>
    </form>
{% endblock %}

catalog/templates/catalog/author_detail.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    <h1>{{ author.last_name }}, {{ author.first_name }}</h1>

    <p>
        {{author.date_of_birth|date:"jS F Y"}} -
        {% if author.date_of_death %}
            {{ author.date_of_death }}
        {% else %}
            not dead yet
        {% endif %}
    </p>
    <div style="margin-left:20px;margin-top:20px">
        <h4>Books</h4>
        <ul>
        {% for book in author.book_set.all %}
            <li>
                <p>
                    <a href="{{ book.get_absolute_url }}">{{ book.title }}</a> ({{ book.bookinstance_set.count }})
                </p>
                <p>
                    {{ book.summary }}
                </p>
            </li>
        {% endfor %}
        </ul>
    </div>
{% endblock %}

catalog/templates/catalog/author_form.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    <form action="" method="post">
        {% csrf_token %}
        <table>
            {{ form.as_table }}
        </table>
        <input class="btn btn-success" type="submit" value="Submit">
        <input class="btn btn-secondary" type="reset" value="Erase">
        <a href="{% url 'authors' %}">
            <button class="btn btn-danger" type="button">Cancel</button>
        </a>
    </form>
{% endblock %}

catalog/templates/catalog/author_list.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    <h1>Author List</h1>
    {% if authors %}
        <ul>
            {% for author in authors %}
                <li>
                    <a href="{{ author.get_absolute_url }}">
                        {{ author.last_name }}, {{ author.first_name }}
                    </a>
                    ({{ author.date_of_birth|date:"jS F Y" }} -
                    {% if author.date_of_death %}
                        {{ author.date_of_death }})
                    {% else %}
                        not dead yet)
                    {% endif %}
                    {% if perms.catalog.change_author %}
                        <a href="{% url 'author-update' author.id %}">
                            <button class="btn btn-sm btn-outline-primary">Edit</button>
                        </a>
                    {% endif %}
                    {% if perms.catalog.delete_author %}
                        <a href="{% url 'author-delete' author.id %}">
                            <button class="btn btn-sm btn-outline-danger">Delete</button>
                        </a>
                    {% endif %}
                </li>
            {% endfor %}
        </ul>
    {% else %}
        <p>Ain't no authors in dat library.</p>
    {% endif %}
    {% if perms.catalog.add_author %}
        <a href="{% url 'author-create' %}">
            <button class="btn btn-primary">Add Author</button>
        </a>
    {% endif %}
{% endblock %}}

catalog/templates/catalog/base_generic.html
<!DOCTYPE html>
<html lang="en">
{% block head %}
    {% include 'catalog/head.html' %}
{% endblock %}
<body>
<div class="container-fluid">
    <div class="row">
        <div class="col-sm-2">
            {% block sidebar %}
                {% include 'catalog/side_bar.html' %}
            {% endblock %}
        </div>
        <div class="col-sm-10 ">
            {% if messages %}
                    <ul class="messages list-group">
                        {% for message in messages %}
                            <li class="list-group-item list-group-item-{% if message.level == 40 %}danger
                                       {% elif message.level == 25 %}success{% endif %}">
                                {{ message }}
                            </li>
                        {% endfor %}
                    </ul>
            {% endif %}
            {% block content %}{% endblock %}

            {% block pagination %}
                {% include 'catalog/pagination.html' %}
            {% endblock %}
        </div>
    </div>
</div>
</body>
</html>

catalog/templates/catalog/book_detail.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    <h1>Title: {{ book.title }}</h1>

    <p><strong>Author:</strong>
        <a href="{% url 'author-detail' book.author.pk %}">{{ book.author }}</a>
    </p>
    <p><strong>Summary:</strong> {{ book.summary }}</p>
    <p><strong>ISBN:</strong> {{ book.isbn }}</p>
    <p><strong>Language:</strong> {{ book.language }}</p>
    <p><strong>Genre:</strong> {{ book.genre.all|join:", " }}</p>

    <div style="margin-left:20px;margin-top:20px">
        <h4>Copies</h4>

        {% for copy in book.bookinstance_set.all %}
            <hr>
            <p class="{% if copy.status == 'a' %}text-success{% elif copy.status == 'm' %}text-danger{% else %}text-warning{% endif %}">
                {{ copy.get_status_display }}
                {% if copy.status == 'l' and copy.borrower == user %} to you
                {% elif copy.status == 'l' and copy.reserver == user %} (you reserved it)
                {% elif copy.status == 'r' and copy.reserver == user %} by you
                {% endif %}
            </p>
            {% if perms.catalog.can_borrow_books %}
                {% if copy.status == 'a' %}
                    <a href="{% url 'borrow-book' copy.id %}">
                        <button class="btn btn-primary">Borrow</button>
                    </a>
                    <a href="{% url 'reserve-book' copy.id %}">
                        <button class="btn btn-primary">Reserve</button>
                    </a>
                {% elif copy.status == 'r' and copy.reserver == user%}
                    <a href="{% url 'borrow-book' copy.id %}">
                        <button class="btn btn-success">Borrow</button>
                    </a>
                    <button class="btn btn-outline-secondary" disabled>Reserve</button>
                {% elif copy.status == 'l' and not copy.borrower == user and not copy.is_reserved %}
                    <button class="btn btn-outline-secondary" disabled>Borrow</button>
                    <a href="{% url 'reserve-book' copy.id %}">
                        <button class="btn btn-primary">Reserve</button>
                    </a>
                {% else %}
                        <button class="btn btn-outline-secondary" disabled>Borrow</button>
                        <button class="btn btn-outline-secondary" disabled>Reserve</button>
                {% endif %}
                {% if copy.reserver == user %}
                    <a href="{% url 'cancel-res' copy.id %}">
                        <button class="btn btn-primary">Cancel Reservation</button>
                    </a>
                {% endif %}
            {% endif %}

            <br>
            {% if copy.due_back %}
                <p><strong>Due to be returned:</strong> {{ copy.due_back }}</p>
            {% endif %}
            <p><strong>Imprint:</strong> {{ copy.imprint }}</p>
            <p class="text-muted"><strong>Id:</strong> {{ copy.id }}</p>
        {% endfor %}
    </div>
{% endblock %}

catalog/templates/catalog/book_list.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    <h1>Book List</h1>
    {% if book_list %}
        <ul>
            {% for book in book_list %}
            <li>
                <a href="{{ book.get_absolute_url }}">{{ book.title }}</a> ({{book.author}})
            </li>
            {% endfor %}
        </ul>
    {% else %}
        <p>There are no books in the library.</p>
    {% endif %}
{% endblock %}}

catalog/templates/catalog/book_renew_librarian.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    <h1>Renew: {{ book_instance.book.title }}</h1>
    <p>Borrower: {{ book_instance.borrower }}</p>
    <p{% if book_instance.is_overdue %} class="text-danger"{% endif %}>Due date: {{ book_instance.due_back }}</p>
{#    {% if form.renewal_date.errors %}#}
{#        <ul>#}
{#            {% for error in form.renewal_date.errors %}#}
{#                <li>{{ error }}</li>#}
{#            {% endfor %}#}
{#        </ul>#}
{#    {% endif %}#}
    <form action="" method="post">
        {% csrf_token %}
        <table>
            {{ form.as_table }}
        </table>
        <input class="btn btn-success" type="submit" value="Submit">
        <input class="btn btn-secondary" type="reset" value="Erase">
        <a href="{% url 'all-borrowed' %}">
            <button class="btn btn-danger" type="button">Cancel</button>
        </a>
    </form>
{% endblock %}

catalog/templates/catalog/bookinstance_list_borrowed_librarians.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    <h1>Borrowed books by all members</h1>

    {% if bookinstance_list %}
        {% regroup bookinstance_list by borrower.username as borrowers_list %}
        <ul class="list-group">
            {% for borrower, borrowed_books in borrowers_list %}
                <li class="list-group-item">
                    {{ borrower }}
                    <span class="badge badge-primary badge-pill">
                        {{ borrowed_books|length }}
                    </span>
                </li>
                <ul class="list-group">
                    {% for bookinst in borrowed_books %}
                        <li class="list-group-item {% if bookinst.is_overdue %}list-group-item-danger{% endif %}">
                            <a href="{% url 'book-detail' bookinst.book.pk %}">{{ bookinst.book.title }}</a>
                            ({{ bookinst.due_back }})
                            {% if perms.catalog.can_renew%}
                                {% if bookinst.has_been_renewed%}
                                    - Already been renewed
                                {% else %}
                                    - <a href="{% url 'renew-book-librarian' bookinst.id %}">Renew</a>
                                {% endif %}
                            {% endif %}
                            {% if perms.catalog.can_mark_returned %}
                                - <a href="{% url 'return-book' bookinst.id %}">Return</a>
                            {% endif %}
                        </li>
                    {% endfor %}
                </ul>
            {% endfor %}
        </ul>
    {% else %}
        <p>There are no books borrowed.</p>
    {% endif %}
{% endblock %}

catalog/templates/catalog/bookinstance_list_borrowed_user.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    {% if bookinstance_list %}
        <h1>
            {% with books_count=bookinstance_list.count %}
                Borrowed book{{ books_count|pluralize }}
                <span class="badge badge-primary">{{ books_count }}</span>
            {% endwith %}
        </h1>
        <ul class="list-group">
            {% for bookinst in bookinstance_list %}
                <li  class="list-group-item {% if bookinst.is_overdue %}list-group-item-danger{% endif %}">
                    <a href="{% url 'book-detail' bookinst.book.pk %}">{{ bookinst.book.title }}</a>
                    (Due back: {{ bookinst.due_back }}
                    {% if bookinst.is_overdue %}
                         - is overdue since {{ bookinst.due_back|timesince }}
                    {% endif %}
                    )
                </li>
            {% endfor %}
        </ul>

    {% else %}
        <h1>Borrowing</h1>
        <p>There are no books borrowed.</p>
    {% endif %}
{% endblock %}

catalog/templates/catalog/bookinstance_list_reserved_user.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    {% if bookinstance_list %}
        <h1>
            {% with books_count=bookinstance_list.count %}
                Reserved book{{ books_count|pluralize }}
                <span class="badge badge-primary">{{ books_count }}</span>
            {% endwith %}
        </h1>
        <ul class="list-group">
            {% for bookinst in bookinstance_list %}
                <li class="list-group-item {% if bookinst.borrower is None %}list-group-item-success{% endif %}">
                    <a href="{% url 'book-detail' bookinst.book.pk %}">{{ bookinst.book.title }}</a>
                    ({% if bookinst.due_back %}
                        Available in {{ bookinst.due_back|timeuntil }}
                    {% else %}
                        Available
                    {% endif %})
                    <a href="{% url 'cancel-res' bookinst.id %}">
                        <button class="btn btn-primary btn-sm">Cancel reservation</button>
                    </a>
                </li>
            {% endfor %}
        </ul>
    {% else %}
        <h1>Reservation</h1>
        <p>You don't have any book reserved.</p>
    {% endif %}
{% endblock %}

catalog/templates/catalog/index.html
{% extends "catalog/base_generic.html" %}

{% block content %}
    <h1>Local Library Home</h1>
    <p>Welcome to LocalLibrary, a website developed by <em>Mozilla Developer Network</em>!</p>
    <h2>Dynamic content</h2>
    <p>The library has the following record counts:</p>
    <ul>
        <li><strong>Books:</strong> {{ num_books }}</li>
        <li><strong>Copies:</strong> {{ num_instances }}</li>
        <li><strong>Copies available:</strong> {{ num_instances_available }}</li>
        <li><strong>Authors:</strong> {{ num_authors }}</li>
    </ul>
    <p>You have visited this page {{ num_visits }}{% if num_visits == 1 %} time{% else %} times{% endif %}.</p>
{% endblock %}

catalog/templates/catalog/pagination.html
{% if is_paginated %}
    <div class="pagination">
        <span class="page-links">
            {% if page_obj.has_previous %}
                <a href="{{ request.path }}?page={{ page_obj.previous_page_number }}">previous</a>
            {% endif %}
            <span class="page-current">
                Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
            </span>
            {% if page_obj.has_next %}
                <a href="{{ request.path }}?page={{ page_obj.next_page_number }}">next</a>
            {% endif %}
        </span>
    </div>
{% endif %}

catalog/templates/catalog/side_bar.html
<ul class="sidebar-nav">
    {% if user.is_authenticated %}
        <li>
            User: {{ user.get_username }}
            (<a href="{% url 'logout' %}?next={% url 'index' %}">Logout</a>)
        </li>
    {% else %}
        <li><a href="{% url 'login' %}?next={% url 'index' %}">Login</a></li>
    {% endif %}
    <hr>
    <li><a href="{% url 'index' %}">Home</a></li>
    <li><a href="{% url 'books' %}">All books</a></li>
    <li><a href="{% url 'authors' %}">All authors</a></li>
    <hr>
    {% if perms.catalog.can_mark_returned %}
        <li>Staff:</li>
        <li><a href="{% url 'all-borrowed' %}">All Borrowed Books</a></li>
    {% elif perms.catalog.can_see_own_borrowed_books %}
        <li>Personnal:</li>
        <li><a href="{% url 'my-borrowed' %}">My Books</a></li>
        <li><a href="{% url 'my-reserved' %}">My Reservations</a></li>
    {% endif %}
</ul>